<template>
  <el-dropdown trigger="click">
    <div class="avatar-box">
      <div class="avatar">
        <img src="@/assets/images/avatar.png" alt="avatar" />
      </div>
      <div class="username">{{ username+'('+userJob+')' }}</div>
      <img class="chevron-down" src="@/assets/images/chevron_down.png" />
    </div>
    <template #dropdown>
      <el-dropdown-menu>
        <el-dropdown-item @click="openDialog('infoRef')">
          <el-icon><User /></el-icon>{{ $t("header.personalData") }}
        </el-dropdown-item>
        <el-dropdown-item @click="openDialog('passwordRef')">
          <el-icon><Edit /></el-icon>{{ $t("header.changePassword") }}
        </el-dropdown-item>
        <el-dropdown-item divided @click="openDrawer">
          <el-icon><Setting /></el-icon>{{ $t("header.settingsLayout") }}
        </el-dropdown-item>
        <el-dropdown-item divided @click="logout">
          <el-icon><SwitchButton /></el-icon>{{ $t("header.logout") }}
        </el-dropdown-item>
      </el-dropdown-menu>
    </template>
  </el-dropdown>
  <!-- infoDialog -->
  <InfoDialog ref="infoRef"></InfoDialog>
  <!-- passwordDialog -->
  <PasswordDialog ref="passwordRef"></PasswordDialog>
</template>

<script setup lang="ts">
import { computed, ref } from "vue";
import { LOGIN_URL } from "@/config";
import { useRouter } from "vue-router";
import { logoutApi } from "@/api/modules/login";
import { useUserStore } from "@/stores/modules/user";
import { ElMessageBox, ElMessage } from "element-plus";
import InfoDialog from "./InfoDialog.vue";
import PasswordDialog from "./PasswordDialog.vue";
import mittBus from "@/utils/mittBus";
const router = useRouter();
const userStore = useUserStore();
const username = computed(() => userStore.userInfo.user_name);
const userJob = computed(() => userStore.userInfo.user_job);

const openDrawer = () => {
  mittBus.emit("openThemeDrawer");
};

// 退出登录
const logout = () => {
  ElMessageBox.confirm("您是否确认退出登录?", "温馨提示", {
    confirmButtonText: "确定",
    cancelButtonText: "取消",
    type: "warning"
  }).then(async () => {
    // // 1.执行退出登录接口
    // await logoutApi();

    // 2.清除 Token
    userStore.setToken("");
    userStore.setAsInfo([]);
    userStore.setUserInfo({})
    userStore.clearAllData()
    localStorage.removeItem('username2');
    localStorage.removeItem('password2');

    // 3.重定向到登陆页
    router.replace(LOGIN_URL);
    ElMessage.success("退出登录成功！");
  });
};

// 打开修改密码和个人信息弹窗
const infoRef = ref<InstanceType<typeof InfoDialog> | null>(null);
const passwordRef = ref<InstanceType<typeof PasswordDialog> | null>(null);
const openDialog = (ref: string) => {
  if (ref == "infoRef") infoRef.value?.openDialog();
  if (ref == "passwordRef") passwordRef.value?.openDialog();
};
</script>

<style scoped lang="scss">
.avatar {
  width: 30px;
  height: 30px;
  overflow: hidden;
  cursor: pointer;
  border-radius: 50%;
  img {
    width: 100%;
    height: 100%;
  }
}
.username {
  cursor: pointer;
  margin: 0 0 0 10px;
  font-size: 15px;
  display: flex;
  align-items: center;
  color: var(--el-header-text-color);
}

.avatar-box {
  display: flex;
  justify-items: center;
  align-items: center;
}

.chevron-down {
  margin-top: 3px;
  margin-left: 5px;
  width: 10px;
  height: 10px;
}
</style>
